
#include <stdio.h>
#include "wm_hal.h"
#include "main.h"

void Error_Handler(void);
static void GPIO_Init(void);

int Read_Flash(int addr_offset, int len);

#define LEN 5000
#define TEST_ADDR 0x08000000
uint8_t test_buf[LEN]={0};

int Read_Flash(int addr_offset, int len)
{
	int i = 0;
	
	memset(test_buf, 0, LEN);
	HAL_FLASH_Read(addr_offset, test_buf, len);
	for (i = 0; i < len; i++)
	{
		printf("%.2X", test_buf[i]);
	}
	printf("\n");

	if (i == len)
	{
		printf("test success\n\r");
	}
	return 0;
}


static int rti_board_start(void)
{
    return 0;
}

INIT_EXPORT(rti_board_start, "0.end");

int main(void)
{
	SystemClock_Config(CPU_CLK_160M);
	printf("\n\renter main\n\r");
	HAL_Init();
	GPIO_Init();
	
	printf("rti_board_start()= 0x%p\n\r", &rti_board_start);
    printf("__rt_init_rti_board_start= 0x%p\n\r", __rt_init_rti_board_start);
    printf("&__rt_init_rti_board_start= %p\n\r", &__rt_init_rti_board_start);

    for (int i = 0; i < 0x120; i++)
    {
        printf("%.2x ", *((char*)rt_object_container+i));
    }
    printf("\n\r");


	while (1)
	{
		HAL_Delay(300);
		HAL_GPIO_WritePin(GPIOB, GPIO_PIN_0, GPIO_PIN_RESET);
		HAL_Delay(300);
		HAL_GPIO_WritePin(GPIOB, GPIO_PIN_1, GPIO_PIN_RESET);
		HAL_Delay(300);
		HAL_GPIO_WritePin(GPIOB, GPIO_PIN_2, GPIO_PIN_RESET);
		HAL_Delay(300);
		HAL_GPIO_WritePin(GPIOB, GPIO_PIN_0, GPIO_PIN_SET);
		HAL_Delay(300);
		HAL_GPIO_WritePin(GPIOB, GPIO_PIN_1, GPIO_PIN_SET);
		HAL_Delay(300);
		HAL_GPIO_WritePin(GPIOB, GPIO_PIN_2, GPIO_PIN_SET);		
		// HAL_Delay(500);
		// HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_0 | GPIO_PIN_1 | GPIO_PIN_2);
		// HAL_Delay(500);	
		// HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_0 | GPIO_PIN_1 | GPIO_PIN_2);

		// printf(".");
		HAL_Delay(1000);
	}
}

static void GPIO_Init(void)
{
	GPIO_InitTypeDef GPIO_InitStruct = {0};
	
	__HAL_RCC_GPIO_CLK_ENABLE();

	GPIO_InitStruct.Pin = GPIO_PIN_0 | GPIO_PIN_1 | GPIO_PIN_2;
	GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT;
	GPIO_InitStruct.Pull = GPIO_NOPULL;
	HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);
	HAL_GPIO_WritePin(GPIOB, GPIO_PIN_0 | GPIO_PIN_1 | GPIO_PIN_2, GPIO_PIN_SET);
	

}

void Error_Handler(void)
{
	while (1)
	{
	}
}

void assert_failed(uint8_t *file, uint32_t line)
{
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
}
